--/bin/euos
include machine.e
atom tm
function testRoutine()
    atom t2,diff
    t2=time()
    diff=t2-tm
    -- I use .096 instead of .1 to give it a little more accuracy(it says
    -- 99.9985% efficiency instead of 100% when nothing else is running, any-
    -- way)
    if diff >= .096 then
	if k_write(1,sprintf("EuOS is operating at about %g%% efficiency\n",(.1/diff)*100)) then
	end if
	return -1
    end if
    return routine_id("testRoutine")
end function
function effmain()
    tick_rate(200)
    tm=time()
    return routine_id("testRoutine")
end function
k_addProgram("efftest",{routine_id("effmain"),"efficiency tester",1})
