--/bin/euos
		   ---------------------------
		   -- Prime Sieve Benchmark --
		   ---------------------------
-- with profile
-- with profile_time (DOS only)

without type_check -- makes no difference

constant BATCH = 50
constant BENCH_TIME = 15

constant SIZE = 500  -- finds primes up to SIZE*2+1
		     -- (only tests odd numbers)
constant ON = 1, OFF = 0
constant SCREEN = 1

sequence flags 

atom t, cycles

function sieve()
    integer prime, start, count, still_prime

    count = 0
    flags = repeat(ON, SIZE)
    for i = 1 to SIZE do
	still_prime = flags[i]
	if still_prime then
	    prime = 2 * i 
	    prime += 1 
	    start = prime + i
	    for k = start to SIZE by prime do
		flags[k] = OFF
	    end for 
	    count += 1
	end if
    end for
    return count
end function
integer p_sieve2
function sieve3()
	for iter = 1 to BATCH do
		if sieve() != 167 then
			puts(SCREEN, "whoops!\n")
		end if
	end for
	cycles = cycles + BATCH
	return p_sieve2
end function
function sieve4()
	integer junk
	t = time() - t
	junk = k_write(SCREEN, sprintf("%6.1f sieves per second\n", cycles / t))

	-- display results
	junk = k_write(SCREEN, "   2") -- 2 is also a prime
	for i = 1 to SIZE do
		if flags[i] then
			junk = k_write(SCREEN, sprintf(" %3d", i*2+1))
		end if
	end for
	return -1
end function
function sieve2()
	if time() < t + BENCH_TIME then
		return routine_id("sieve3")
	else
		return routine_id("sieve4")
	end if
end function
p_sieve2 = routine_id("sieve2")
function sieve1()
	integer junk
	junk = k_write(SCREEN, "prime sieve benchmark ...\n")
	cycles = 0
	t = time()
	return p_sieve2
	t = time() - t
	printf(SCREEN, "%6.1f sieves per second\n", cycles / t)

	-- display results
	puts(SCREEN, "   2") -- 2 is also a prime
	for i = 1 to SIZE do
		if flags[i] then
			printf(SCREEN, " %3d", i*2+1)
		end if
	end for
end function

k_addProgram("sieve",{routine_id("sieve1"),"Sieve",1})
